<?php
/*
Plugin Name: Keyword Insertion Plugin
Plugin URI: http://keywordinsertionplugin.com/
Description: This plugin grabs the keywords visitors used to reach your web page or post and displays them using short-codes or in the template using template-tags.
Version: 2.2
Author: WP Internet Marketing
Author URI: http://wp-internetmarketing.com
*/
 
 // Pre-2.6 compatibility
if ( ! defined( 'WP_CONTENT_URL' ) )
      define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
      define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
      define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );
	  
// Hook for adding admin menus
add_action('admin_menu', 'wp_keywords_add_menu');

// Adding the admin Menu
function wp_keywords_add_menu() {
    add_submenu_page('options-general.php', 'Keyword Options', 'Keyword Options', 10, __FILE__, 'wp_keywords_add_page');
}

// action function for adding the administrative page
function wp_keywords_add_page() { ?>
<style type="text/css">
.codeSampleBox {
	font-size:11px;
	margin:0 1px;
	padding:1px 3px;
	background: #EAEAEA;
}

#shortCodeManipulation td, #templateTagManipulation td {
	padding: 0 2px;
}

#shortCodeManipulation td .codeSampleBox, #templateTagManipulation td .codeSampleBox {
	width:100%;
}
</style>
<script src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/jquery.blockUI.js" type="text/javascript"></script>
<div class="wrap">
<h2>Wp-Keywords.</h2>

<form method="post" action="options.php" id="wp-keywords-form">
<?php wp_nonce_field('update-options'); ?>

<table class="form-table">

<tr valign="bottom">
<td colspan="2" id="templateTagManipulation">
	<table width="585px">
		<tr>
			<td><b>Template Tag Identifier</b></td>
			<td><b>Default Keyword Text</b></td>
			<td></td>
		</tr>
		<tr><td colspan="3"><hr/></td></tr>
	</table>
	<table width="585px">
		<tbody id="TemplateTagContainer" >
		</tbody>
	</table>
	<table width="585px">
		<tr>
			<td><b>Template Tag Identifier</b></td>
			<td><b>Default Keyword Text</b></td>
		</tr>
		<tr>
			<td><input style="width: 210px;" id="templatetag_id" type="text" value="" /></td>
			<td><input style="width: 300px;" id="templatetag_text" type="text" value="" /></td>
			<td><img src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/add-icon.png" onclick="AddTemplateTags()" title="Add" style="cursor: pointer" /></td>
		</tr>
		<tr>
			<td id="templatetag_errorMessage" colspan="3">				
			</td>
		</tr>
	</table>
	<input style="width: 300px;" id="wp_keywords_default_template_tag_text" name="wp_keywords_default_template_tag_text" type="hidden" style="vertical-align:top;" value="<?php echo get_option('wp_keywords_default_template_tag_text'); ?>" />
</td>
</tr>

<tr><th></th><td></td></tr>
<tr><th></th><td></td></tr>

<tr valign="bottom">
<td colspan="2" id="shortCodeManipulation">
	<table width="585px">
		<tr>
			<td><b>Shortcode Identifier</b></td>
			<td><b>Default Keyword Text</b></td>
			<td></td>
		</tr>
		<tr><td colspan="3"><hr/></td></tr>
	</table>
	<table width="585px">
		<tbody id="shortCodeContainer" >
		</tbody>
	</table>
	<table width="585px">
		<tr>
			<td><b>Shortcode Identifier</b></td>
			<td><b>Default Keyword Text</b></td>
		</tr>
		<tr>
			<td><input style="width: 210px;" id="shortcode_id" type="text" value="" /></td>
			<td><input style="width: 300px;" id="shortcode_text" type="text" value="" /></td>
			<td><img src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/add-icon.png" onclick="Add()" title="Add" style="cursor: pointer" /></td>
		</tr>
		<tr>
			<td id="errorMessage" colspan="3">				
			</td>
		</tr>
	</table>
	<input style="width: 300px;" id="wp_keywords_default_shortcode_text" name="wp_keywords_default_shortcode_text" type="hidden" style="vertical-align:top;" value="<?php echo get_option('wp_keywords_default_shortcode_text'); ?>" />
</td>
</tr>

</table>
<script type="text/javascript">
	if(typeof String.prototype.trim !== 'function') {
	  String.prototype.trim = function() {
		return this.replace(/^\s+|\s+$/g, ''); 
	  }
	}
	var items;
	
	function Edit(index) {
		document.getElementById('shortcode_text_'+index).disabled = false;
		document.getElementById('editButton_'+index).style.display = "none";
		document.getElementById('acceptButton_'+index).style.display = "inline";
		document.getElementById('acceptButton_'+index).style.cursor = "pointer";
	}
	
	function Accept(index) {
		document.getElementById('shortcode_text_'+index).disabled = true;
		document.getElementById('editButton_'+index).style.display = "inline";
		document.getElementById('acceptButton_'+index).style.display = "none";
		items[index][1] = document.getElementById('shortcode_text_'+index).value;
		
		Fill();
		jQuery.blockUI();
		document.getElementById('wp-keywords-form').submit();
	}
	
	function Delete(index) {
		items.splice(index,1);
		
		var myTable = document.getElementById('shortCodeContainer');
		while(myTable.hasChildNodes()) {
			myTable.removeChild(myTable.firstChild);
		}
		for(var i = 0; i < items.length; i++) {
			createTable(myTable, i);
		}
		
		Fill();
		jQuery.blockUI();
		document.getElementById('wp-keywords-form').submit();
	}
	
	function Add() {
		var l;
		var unique = true;
		var tempArray = new Array(2);
		tempArray[0] = document.getElementById('shortcode_id').value.trim();
		tempArray[1] = document.getElementById('shortcode_text').value.trim();
		
		for(var i = 0; i < items.length; i++) {
			if(items[i][0] == tempArray[0]) {
				unique = false;
			}
		}
		
		if(tempArray[0].trim() != "") {
			if(unique) {
				document.getElementById('shortcode_id').value = '';
				document.getElementById('shortcode_text').value = '';
				
				if(items) { l = items.length; items.push(tempArray); } else { l = 0; items = new Array(1); items[0] = tempArray; }
				
				var myTable = document.getElementById('shortCodeContainer');
				createTable(myTable, l);
				
				Fill();
				document.getElementById('errorMessage').innerHTML = '';
				jQuery.blockUI();
				document.getElementById('wp-keywords-form').submit();
			} else {
				document.getElementById('errorMessage').innerHTML = '<small class="error">Shortcode Identifier should be a unique value</small>';
			}
		} else {
			document.getElementById('errorMessage').innerHTML = '<small class="error">You should enter a Shortcode Identifier</small>';
		}
	}
	
	function Fill() {
		var result = '';
		for(var i = 0; i < items.length; i++) {
			result += items[i][0] + "::";
			result += items[i][1] + "##";
		}
		document.getElementById('wp_keywords_default_shortcode_text').value = result;
	}
	
	function createTable(myTable, index) {
		var newRow = document.createElement("tr");
		newRow.id = index+"_1";
		var newCell = document.createElement("td");
		newCell.innerHTML = '<input disabled="true" style="width: 210px;" id="shortcode_id_'+index+'" type="text" value="'+items[index][0]+'" />';
		newRow.appendChild(newCell);
		newCell = document.createElement("td");
		newCell.innerHTML = '<input disabled="true" style="width: 300px;" id="shortcode_text_'+index+'" type="text" value="'+items[index][1]+'" />';
		newRow.appendChild(newCell);
		newCell = document.createElement("td");
		newCell.innerHTML = '<img style="display:none;" id="acceptButton_'+index+'" src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/accept-icon.png" onclick="Accept('+index+')" title="Accept Changes" style="cursor: pointer" /><img id="editButton_'+index+'" src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/page-edit-icon.png" onclick="Edit('+index+')" title="Edit" style="cursor: pointer" />&nbsp;<img src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/delete-icon.png" onclick="Delete('+index+')" title="Delete" style="cursor: pointer" />';
		newRow.appendChild(newCell);
		myTable.appendChild(newRow);

		newRow = document.createElement("tr");
		newRow.id = index+"_2";
		newCell = document.createElement("td");
		newCell.colSpan = "3";
		newCell.innerHTML = '<small>To insert this keyword into a page or post you have to use the following SHORTCODE</small><br/><input readonly="readonly" id="shortcode_1" type="text" value="[keyword id=\''+items[index][0]+'\']" class="codeSampleBox" />';
		newRow.appendChild(newCell);
		myTable.appendChild(newRow);
		
		newRow = document.createElement("tr");
		newRow.id = index+"_3";
		newCell = document.createElement("td");
		newCell.colSpan = "3";
		newCell.innerHTML = '<hr/>';
		newRow.appendChild(newCell);
		myTable.appendChild(newRow);
	}
	
	function InitialiseShortTags() {
		var input = document.getElementById('wp_keywords_default_shortcode_text').value;
		
		var tempArray = input.split('##');
		var tempInnerArray = new Array(2);

		items = new Array(1);
		for(var i = 0; i < tempArray.length; i++) {
			tempInnerArray = tempArray[i].split("::");
			items[i] = tempInnerArray;
		}
		
		items.pop();
		
		var myTable = document.getElementById('shortCodeContainer');
		while(myTable.hasChildNodes()) {
			myTable.removeChild(myTable.firstChild);
		}
		for(var i = 0; i < items.length; i++) {
			createTable(myTable, i);
		}
	}
	InitialiseShortTags();
</script>
<script type="text/javascript">
	var Templateitems;
	
	function EditTemplateTags(index) {
		document.getElementById('templatetag_text_'+index).disabled = false;
		document.getElementById('templatetag_editButton_'+index).style.display = "none";
		document.getElementById('templatetag_acceptButton_'+index).style.display = "inline";
		document.getElementById('templatetag_acceptButton_'+index).style.cursor = "pointer";
	}
	
	function AcceptTemplateTags(index) {
		document.getElementById('templatetag_text_'+index).disabled = true;
		document.getElementById('templatetag_editButton_'+index).style.display = "inline";
		document.getElementById('templatetag_acceptButton_'+index).style.display = "none";
		Templateitems[index][1] = document.getElementById('templatetag_text_'+index).value;
		
		FillTemplateTags();
		jQuery.blockUI();
		document.getElementById('wp-keywords-form').submit();
	}
	
	function DeleteTemplateTags(index) {
		Templateitems.splice(index,1);
		
		var myTable = document.getElementById('TemplateTagContainer');
		while(myTable.hasChildNodes()) {
			myTable.removeChild(myTable.firstChild);
		}
		for(var i = 0; i < Templateitems.length; i++) {
			createTableTemplateTags(myTable, i);
		}
		
		FillTemplateTags();
		jQuery.blockUI();
		document.getElementById('wp-keywords-form').submit();
	}
	
	function AddTemplateTags() {
		var l;
		var unique = true;
		var tempArray = new Array(2);
		tempArray[0] = document.getElementById('templatetag_id').value.trim();
		tempArray[1] = document.getElementById('templatetag_text').value.trim();
		
		for(var i = 0; i < Templateitems.length; i++) {
			if(Templateitems[i][0] == tempArray[0]) {
				unique = false;
			}
		}
		
		if(tempArray[0].trim() != "") {
			if(unique) {
				document.getElementById('templatetag_id').value = '';
				document.getElementById('templatetag_text').value = '';
				
				if(Templateitems) { l = Templateitems.length; Templateitems.push(tempArray); } else { l = 0; Templateitems = new Array(1); Templateitems[0] = tempArray; }
				
				var myTable = document.getElementById('TemplateTagContainer');
				createTableTemplateTags(myTable, l);
				
				FillTemplateTags();
				document.getElementById('templatetag_errorMessage').innerHTML = '';
				jQuery.blockUI();
				document.getElementById('wp-keywords-form').submit();
			} else {
				document.getElementById('templatetag_errorMessage').innerHTML = '<small class="error">Template Tag Identifier should be a unique value</small>';
			}
		} else {
			document.getElementById('templatetag_errorMessage').innerHTML = '<small class="error">You should enter a Template Tag Identifier</small>';
		}
	}
	
	function FillTemplateTags() {
		var result = '';
		for(var i = 0; i < Templateitems.length; i++) {
			result += Templateitems[i][0] + "::";
			result += Templateitems[i][1] + "##";
		}
		document.getElementById('wp_keywords_default_template_tag_text').value = result;
	}
	
	function createTableTemplateTags(myTable, index) {
		var newRow = document.createElement("tr");
		newRow.id = index+"_1";
		var newCell = document.createElement("td");
		newCell.innerHTML = '<input disabled="true" style="width: 210px;" id="templatetag_id_'+index+'" type="text" value="'+Templateitems[index][0]+'" />';
		newRow.appendChild(newCell);
		newCell = document.createElement("td");
		newCell.innerHTML = '<input disabled="true" style="width: 300px;" id="templatetag_text_'+index+'" type="text" value="'+Templateitems[index][1]+'" />';
		newRow.appendChild(newCell);
		newCell = document.createElement("td");
		newCell.innerHTML = '<img style="display:none;" id="templatetag_acceptButton_'+index+'" src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/accept-icon.png" onclick="AcceptTemplateTags('+index+')" title="Accept Changes" style="cursor: pointer" /><img id="templatetag_editButton_'+index+'" src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/page-edit-icon.png" onclick="EditTemplateTags('+index+')" title="Edit" style="cursor: pointer" />&nbsp;<img src="<?php echo WP_PLUGIN_URL; ?>/wp-keywords/images/delete-icon.png" onclick="DeleteTemplateTags('+index+')" title="Delete" style="cursor: pointer" />';
		newRow.appendChild(newCell);
		myTable.appendChild(newRow);

		newRow = document.createElement("tr");
		newRow.id = index+"_2";
		newCell = document.createElement("td");
		newCell.colSpan = "3";
		newCell.innerHTML = '<small>To insert the keyword directly into the template you have to use the following TEMPLATE TAG</small><br/><input readonly="readonly" id="templatetag_1" type="text" value="&lt;?php if(function_exists(\'show_keywords\')) { show_keywords(\''+Templateitems[index][0]+'\'); } ?&gt;" class="codeSampleBox" />';
		newRow.appendChild(newCell);
		myTable.appendChild(newRow);
		
		newRow = document.createElement("tr");
		newRow.id = index+"_3";
		newCell = document.createElement("td");
		newCell.colSpan = "3";
		newCell.innerHTML = '<hr/>';
		newRow.appendChild(newCell);
		myTable.appendChild(newRow);
	}
	
	function InitialiseTemplateTags() {
		var input = document.getElementById('wp_keywords_default_template_tag_text').value;
		
		var tempArray = input.split('##');
		var tempInnerArray = new Array(2);

		Templateitems = new Array(1);
		for(var i = 0; i < tempArray.length; i++) {
			tempInnerArray = tempArray[i].split("::");
			Templateitems[i] = tempInnerArray;
		}
		
		Templateitems.pop();
		
		var myTable = document.getElementById('TemplateTagContainer');
		while(myTable.hasChildNodes()) {
			myTable.removeChild(myTable.firstChild);
		}
		for(var i = 0; i < Templateitems.length; i++) {
			createTableTemplateTags(myTable, i);
		}
	}
	InitialiseTemplateTags();
</script>
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="wp_keywords_default_shortcode_text, wp_keywords_default_template_tag_text" />
<p class="submit">
<input type="submit" style="display: none;" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>
</form>
</div>
<?php }

function wp_keywords_get_referer() {
	// Break out quickly so we don't waste CPU cycles on non referrals
	if (!isset($_SERVER['HTTP_REFERER']) || ($_SERVER['HTTP_REFERER'] == '')) return false;

	$referer_info = parse_url($_SERVER['HTTP_REFERER']);
	$referer = $referer_info['host'];

	// Remove www. is it exists
	if(substr($referer, 0, 4) == 'www.')
		$referer = substr($referer, 4);

	return $referer;
}

function wp_keywords_get_delimiter($ref) {
	// Search engine match array
	// Used for fast delimiter lookup for single host search engines.
	// Non .com Google/MSN/Yahoo referrals are checked for after this array is checked
	// Search engines that send the term as a path are flagged with a delim of '&'

	$search_engines = array('google.com' => 'q',
			'go.google.com' => 'q',
			'maps.google.com' => 'q',
			'local.google.com' => 'q',
			'blogsearch.google.com' => 'q',
			'bing.com' => 'q',
			'search.yahoo.com' => 'p',
			'search.msn.com' => 'q',
			'msxml.excite.com' => '&',
			'a9.com' => '&',
			'search.lycos.com' => 'query',
			'alltheweb.com' => 'q',
			'search.aol.com' => 'query',
			'search.iwon.com' => 'searchfor',
			'ask.com' => 'q',
			'ask.co.uk' => 'ask',
			'search.cometsystems.com' => 'qry',
			'hotbot.com' => 'query',
			'overture.com' => 'Keywords',
			'metacrawler.com' => 'qkw',
			'search.netscape.com' => 'query',
			'looksmart.com' => 'key',
			'dpxml.webcrawler.com' => 'qkw',
			'search.earthlink.net' => 'q',
			'search.viewpoint.com' => 'k',
			'mamma.com' => 'query');

	$delim = false;

	// Check to see if we have a host match in our lookup array
	if (isset($search_engines[$ref])) {
		$delim = $search_engines[$ref];
	} else {
		// Lets check for referrals for international TLDs and sites with strange formats

		// Optimizations
		$sub13 = substr($ref, 0, 13);

		// Search string for engine
		if(substr($ref, 0, 7) == 'google.')
			$delim = "q";
		elseif($sub13 == 'search.atomz.')
			$delim = "sp-q";
		elseif(substr($ref, 0, 11) == 'search.msn.')
			$delim = "q";
		elseif($sub13 == 'search.yahoo.')
			$delim = "p";
		elseif(preg_match('/home\.bellsouth\.net\/s\/s\.dll/i', $ref))
			$delim = "bellsouth";
	}

	return $delim;
}

function wp_keywords_get_terms($d) {
	$query_array = array();
	$query_terms = null;

	// A few search engines include the query as a URL path, not a variable (Excite/A9, etc)
	if ($d == '&') {
		$query = urldecode(substr(strrchr($_SERVER['HTTP_REFERER'], '/'), 1));
	} else {
		// Get raw query
		$query = explode($d.'=', $_SERVER['HTTP_REFERER']);
		$query = explode('&', $query[1]);
		$query = urldecode($query[0]);
	}

	// Remove quotes, split into words, and format for HTML display
	$query = str_replace("'", '', $query);
	$query = str_replace('"', '', $query);
	$query_array = preg_split('/[\s,\+\.]+/',$query);
	$query_terms = implode(' ', $query_array);
	$terms = htmlspecialchars(urldecode($query_terms));

	return $terms;
}

function wp_keywords_getinfo() {
	$referer = wp_keywords_get_referer();
	if (!$referer) return false;
	$delimiter = wp_keywords_get_delimiter($referer);

	if($delimiter) { 
		return wp_keywords_get_terms($delimiter);
	} 
}

function show_keywords($atts) {
	$items = explode("##", get_option('wp_keywords_default_template_tag_text'));
	$innerItem;
	foreach($items as $item) {
		$innerItem = explode("::", $item);
		
		if($innerItem[0] == $atts) {
			if(wp_keywords_getinfo() == false) {
				echo $innerItem[1];
			} else {
				echo wp_keywords_getinfo();
			}
		}
	}
}

function return_keywords($atts) {
	extract(shortcode_atts(array('id' => ''), $atts));
	$items = explode("##", get_option('wp_keywords_default_shortcode_text'));
	$innerItem;
	foreach($items as $item) {
		$innerItem = explode("::", $item);
		
		if($innerItem[0] == $id) {
			if(wp_keywords_getinfo() == false) {
				return $innerItem[1];
			} else {
				return wp_keywords_getinfo();
			}
		}
	}
}

add_shortcode('keyword', 'return_keywords')
?>